@echo off
echo   This batch file will plot a map from
echo   the Bright Stars Catalogue
echo                      centered on a body
echo   whose orbital elements are contained in a [file] which is given as
echo    @[file]
echo            as a first parameter.

if "%1"=="" goto end
shift

@echo on
posi C %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 >%temp%RADecl.tmp
if errorlevel==1 goto map
@echo off
echo          -------------------
echo Sorry, some parameter is in conflict with the programme Posi.       
goto end

:map
@echo off
echo  Some parameters of the mapping programme Map_BSC are predefined here:
echo                      Radius of the field as 20 degrees,
echo                          Base of the faintness scale is chosen as -100 cmag
echo                               Include marks each 30 degrees of Ecliptic

@echo on
map_bsc @%temp%RADecl.tmp r20 b-100 ie $%0 %1 %2 %3 %4 %5 %6 %7 %8 %9
:end
