set term vgamono
set title 'refraction / 1 millidegree'
set xlabel 'angular height / 1 degree'
cotg(x)=tan((90-x)*pi/180)
refr(x)=1000*(60.236-0.070*(cotg(x)**2))*cotg(x)/3600  # acc. to Jan Vondrak
n=1.0002917
plrf(x)=1000*(180*acos(cos(x*pi/180)/n)/pi - x)  # as if a plane surface
pol(x)= 5.0528E+02 + x*(-1.5278E+02 + x*( 2.9775E+01 + x*(-3.3643E+00 + x*( 1.6082E-01))))
xr(x)=x*pi/180
flat(x)=1000*(-x+180*sqrt(xr(x)**2+0.000583)/pi)
plot [-2 to 40] [0 to 1000] "refrac.txt" using 5:4, pol(x), refr(x), plrf(x)
#plot [4 to 30] [0 to 220] "refrac.txt" using 5:4, pol(x), refr(x), plrf(x), flat(x)


