 {~ Screen writing with SansSerif letters (scaled by + or - key); Czech code ~}

program s; {psan psmem  Sans - hraka pro Matje od Jenka Hollana}

  {by Jan Hollan for his children;
       edited from a Czech source code by Ondrej Cada
       that the author got in a package contaning *.chr
       with accented Czech letters in Kamenicky's code table}


uses crt, graph, G_Scree, dos;

const
   cl=#13#10;
     KONEC=chr(27);
     ZVETSI='+';
     ZMENSI='-';

procedure testgrapherror;
{ zjist, dolo-li k chyb grafickho driveru }
var  i : integer;
begin
  i:=graphresult;
  if i<>grOk then begin
    closegraph;  { je nutn ukonit prci v grafickm mdu }
    writeln('Chyba grafickho driveru ',grapherrormsg(i));
    halt(0);
  end
end;

{ hlavn program }

var
  pathtodriver : string;
  argument,gd,i,gm,font,size,Y : integer;

label 001;

begin
  FileMode:=0;
  pathtodriver:=GetEnv('BGI');
  argument:=1;
  size:=16;

(*  writeln('FontTest ver 1.0 (c) OCSoftware');
  writeln('         Created using Borland''s Turbo C');

  if copy(paramstr(1),1,1)='/' then begin  { je zadn adres s BGI driverem }
    pathtodriver:=copy(paramstr(1),2,length(paramstr(1))-1);
       { pomoc '+1' se pesko lomtko }
    inc(argument);           { parametr se po zpracovn pesko }
  end;
  if paramcount<argument then begin  { je-li pli mlo parametr }
    writeln('Voln :   FONTTEST [/<adres s BGI drivery>] <jmno souboru> <text>');
    writeln('Ovldn : |+|      zvtit text');
    writeln('           |-|      zmenit text');
    writeln('           |Esc|    konec');
  end else begin
*)
    IF Paramcount=0 then
     begin
       writeln(
'Psan psmem  Sans -- hraka od Jenka pro Matje Hollana',cl,
'vznikl adaptac programu Fonttest -- viz adres tp\bgi',cl);
       Highvideo;
       writeln(
'S <text v kdu b Kamenickch>',cl);
       Lowvideo;
       writeln(cl,
'Text za pkazem S se zobraz psacm psmem',cl,
' a pomoc pravch klves + a - lze mnit jeho velikost',cl);

       writeln(
'(Writing with Sans font -- toy from Jenk for Matj Hollan,',cl,
'adapted from programme Fonttest - see directory tp\bgi',cl,

'S <Text (characters over 127 assumed in Kamenicky code table)>',cl,cl,

'Text behind command S is displayed in "handwriting"',cl,
' and by + and - keys it can be scaled.)',cl,cl,

' Source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
       halt
     end;

    detectgraph(gd,gm);
    initgraph(gd,gm,pathtodriver);
    testgrapherror;
    font:=installuserfont({paramstr(argument)} 'sans'); { instalace poadovanho fontu }
    testgrapherror;
    settextstyle(font,0,USERCHARSIZE); { ... a jeho nastaven }
    while true do
     begin
      setusercharsize(size,6,size,6);  { nastaven velikosti textu }
      testgrapherror;
      cleardevice; Y:= 0; MoveTo(size*2,0);
      for i:=argument to paramcount do
       begin  { vechny zbyl parametry ... }
        if TextWidth(ParamStr(i)) > 640-GetX then
         begin
          Inc(Y,Round(TextHeight('')));
          outtextXY(size,Y,paramstr(i));
          MoveTo(TextWidth(ParamStr(i)),Y)
         end
        else outtext(paramstr(i)); {       ... se vyp }
        outtext(' ');
       end;
001 :
      case readkey of
       { KONEC : begin
          closegraph;
          testgrapherror;
          exit;
        end;
      }  ZVETSI :
          inc(size);
        ZMENSI :
          if size>1 then dec(size);
{        'T','t': if not PriGScrC then exit;}
        else   begin
          closegraph;
          testgrapherror;
          exit;
               end;
         { goto 001; }
      end
     end
{  end}
end.

{ konec souboru fonttest.c }
