    {~ Repairing texts: character 255 to 32 (blank), or any to any ~}

program Nonsense_to_blank;

uses dos,
     str_num;


type nonsenses = set of byte;
var infile : file;
    inbuf : array [1..64000] of byte;
    NumRead,i,NBuf:word; i1,i2:byte;
    OldFilePos: longint;
    FoundName : pathstr;
const NFile : word = 0;
    nonsense : nonsenses = [{26,}255];
    replacement: byte=32;

h1=cl+
'Nons2Bla <text file name> [#[:#] of character to replace] [# of replacement]'+cl+
'                          (default 255)              (default 32, i.e. blank)'+cl+
'replaces characters with codes in the given interval by another character'+cl;
h2=cl+
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

procedure help;
begin
 write(h1,h2);
 halt;
end;

begin
if (paramcount<1) or ((paramcount>0) and (pos('?',paramstr(1))>0)) then
 help;
{FoundName:=FSearch(ParamStr(1),'');
if FoundName='' then
 begin
  writeln;
  write('There is no file >>');
  write(ParamStr(1));
  writeln('<<. Spell the name correctly, please.');
  halt;
 end;
}
{$I-}
assign (InFile,ParamStr(1));
reset (InFile,1);
if ioresult<>0 then 
 begin
  writeln;
  write('There is no file >>');
  write(ParamStr(1));
  writeln('<<. Spell the name correctly, please.');
  halt;
 end;
{$I+} 
if paramcount>1 then
 begin
  if ItemCountD(':',paramstr(2))=1 then
   begin
    i:=ss2i(paramstr(2),1);
    nonsense:=[i];
   end
  else
   begin
    i1:=I_S(ItemStrD(':',1,paramstr(2)));
    i2:=I_S(ItemStrD(':',2,paramstr(2)));
    nonsense:=[i1..i2];
   end;
  if paramcount>2 then
   replacement:=ss2i(paramstr(3),1);
 end;
while not eof(InFile) do
 begin
  OldFilePos:=FilePos(infile);
  blockread (infile,inbuf,64000,NumRead);
  if NumRead>0 then
   begin
    NBuf:=0;
    for i:=1 to NumRead do
     if inbuf[i] in nonsense then
      begin
       inc(Nbuf);
       inc(Nfile);
       inbuf[i]:=replacement;
      end;
    if Nbuf>0 then
     begin
      seek(infile,OldFilePos);
      blockwrite(infile,inbuf,NumRead);
     end;
   end;
 end;
writeln('There were ',NFile,' replaced characters ');
close(InFile);
end.

