program off__k_7;
uses crt, angles_o;
var inFile, outFile: text;
    Outname: string;
    linestr: string;
    j:byte;

procedure help;
begin
writeln;
writeln(
'The program Off__K_7 filters out the three lines, ',
   'which start with <Esc>[7');
highvideo;
writeln('Off__K_7 <input file> [output file]');
lowvideo;
writeln;
writeln('Jan Hollan, N.Copernicus Obs. and Planetarium, Brno, 1994-01-18',
#13#10,
'source code available at http://astro.sci.muni.cz/pub/hollan/programmes'
);

halt;
end;

begin
if paramcount<1 then help;
if not rt_reset('',inFile,paramstr(1)) then halt;
 if paramcount<2 then outName:=copy(paramstr(1),1,pos('.',paramstr(1)))+'txt'
                else outName:=paramstr(2);
 if not rt_rewrite(outFile,outName) then begin close(InFile); halt end;
 while not eof(inFile) do
 begin
  readln(inFile,linestr);
  if (copy(linestr,1,3)=#27+'[7') then
    for j:=1 to 3 do readln(inFile,linestr);
  writeln(outFile,linestr)
 end;
close(inFile);
close(outFile);
end.
