program offE_Esc;
uses crt, angles_o;
var inFile, outFile: text;
    Outname: string;
    linestr: string;
    j:byte;

procedure help;
begin
writeln;
writeln(
'The program Offe_Esc filters out all empty lines, ',
   'and lines starting with <Esc>');
highvideo;
writeln('Offe_Esc <input file> [output file]');
lowvideo;
writeln;
writeln('Jan Hollan, N.Copernicus Obs. and Planetarium, Brno, 1994-01-18'
,#13#10,
'source code available at http://astro.sci.muni.cz/pub/hollan/programmes'
);

halt;
end;

begin
if paramcount<1 then help;
if not rt_reset('',inFile,paramstr(1)) then halt;
 if paramcount<2 then outName:=copy(paramstr(1),1,pos('.',paramstr(1)))+'txt'
                else outName:=paramstr(2);
 if not rt_rewrite(outFile,outName) then begin close(InFile); halt end;
 while not eof(inFile) do
 begin
  repeat readln(inFile,linestr);
  until not (linestr='');
  if not (linestr[1]=#27) then writeln(outFile,linestr)
 end;
close(inFile);
close(outFile);
end.
