program offEscK;
uses crt;
var intext, out: text;
    linestr,outext:string;

procedure help;
begin
writeln;
writeln(
'The program OffEscK filters out the sequence ',
      ': <Esc> [ K ',
' at the beginning of lines:');
highvideo;
writeln('OffEscK <input file> [output file]');
lowvideo;
writeln;
writeln('Jan Hollan, N.Copernicus Obs. and Planetarium, Brno, 1994-01-18');
halt;
end;

procedure rt_reset(var f1: text;f:string);
begin
 {$I-}
 assign(f1,f);
 reset(f1);
 if ioresult<>0 then
  begin
   writeln;
   write('There is no file ');
   highvideo;
   write(f);
   lowvideo;
   writeln('. Spell the name correctly, please.');
   help
  end;
  {$I+}
end;

procedure rt_rewrite(var f1: text; f:string);
begin
 {$I-}
 assign(f1,f);
 rewrite(f1);
 if ioresult<>0 then
  begin
   writeln;
   write('The output file ');
   highvideo;
   write(f);
   lowvideo;
   writeln(' cannot be opened. Wrong name (or disk full?).');
   help
  end;
  {$I+}
end;



begin
if paramcount<1 then help;
rt_reset(intext,paramstr(1));
if paramcount<2 then outext:=copy(paramstr(1),1,pos('.',paramstr(1)))+'txt'
                else outext:=paramstr(2);
rt_rewrite(out,outext);
while not eof(intext) do
 begin
  readln(intext,linestr);
  if copy(linestr,1,4)=':'+#27+'[K' then linestr:=copy(linestr,5,length(linestr)-4);
  writeln(out,linestr)
 end;
close(intext);
close(out);
end.
