 {~ Conversion from decimal to hexadecimal and vice versa ~}

unit HDConv;  {hex to decimal or vice versa,
                   93-02-02 Jan Hollan.}
(*  Copyright (C) 1999 Jan Hollan;
  by "program" this unit is further meant.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

interface
var
 HexS : string[8];
 Code: integer;
 Decadic: longint;
const
 HexLett : array [0..15] of char
         = '0123456789ABCDEF';

function HexToDec:Longint;
function DecToHex:string;
function DecToHexP(dn:longint):string;

implementation
 var i, L: byte;
     HexB : array [0..8] of byte absolute HexS;
     Pow : array[0..7] of longint;

function HexToDec:Longint;
begin
     Decadic:= 0;
     Code:=0;
     L:= HexB[0];
     for  i:= 1 to L do
       begin
         if not HexB[L-i+1] in [48..57,65..70,97..102] then
            begin Code:=L-i+1; exit end;
         if HexB[L-i+1]<58 then
            Decadic:= Decadic + (HexB[L-i+1]-48)*Pow[i-1]
           else
            if HexB[L-i+1]<71 then
           Decadic:= Decadic + (HexB[L-i+1]-55)*Pow[i-1]
            else
           Decadic:= Decadic + (HexB[L-i+1]-87)*Pow[i-1];
       end;
     HexToDec:=Decadic;
end;

function DecToHex:string;
var Start:boolean;
begin
     Start:= False;
     HexS:='';
     for  i:= 7 downto 0  do
       begin
         L:= Decadic div Pow[i];
         if L>0 then
            begin
              Start:=True;
              HexS:=HexS + HexLett[L];
              Dec(Decadic,L*Pow[i]);
            end
         else
            if Start then
              HexS:=HexS + '0';
       end;
     DecToHex:=HexS;
end;

 function DecToHexP(dn:longint):string;
begin
 Decadic:=DN;
 DecToHexP:=DecToHex;
end;

begin
     Pow[0]:=1;
     for i:= 1 to 7 do
       Pow[i]:=Pow[i-1]*16;
end.