 {Days, hours, minutes to days; length of time intervals ~}

program dhm2days; {unknown author,
                   adapted to some degree of sanity by J.Hollan}

const
cl=#13#10;
h1=
'dhm2days  dd:hh:mm  [dd:hh:mm  [<width> [unit]]]'+cl+
' (two parameters will give the length of interval as well'+cl+
'  the third parameter will divide that length afterwards)'+cl+cl;

ra:array[1..4] of real = (0,0,0,0);
c:string[1]='';

procedure help;
begin
 write(h1); 
 halt
end;

var
 b_cycle, b_count, i_begin, i_len, b_days:byte;
 w_days:real;
 i:integer;
 s:string;
 days:array[1..2] of real;

begin
if paramcount=0 then help;
if paramcount>1 then b_days:=2 else b_days:=1;
for b_cycle:=1 to b_days do
 begin
  b_count:=1;
  s:=paramstr(b_cycle);
  if pos('?',s)>1 then help;
  i_begin:=1;
  i_len:=length(s);
  repeat
   val(copy(s,i_begin,i_len),ra[b_count],i);
   if i>1 then
    begin
     i_len:=i-1;
     val(copy(s,i_begin,i_len),ra[b_count],i);
     inc(b_count);
     inc(i_begin,i_len+1);
     i:=i_len+1;
     i_len:=length(s)-i_begin+1;
    end;
  until (i<2) or (i_len=0);
  days[b_cycle]:=ra[1]+(ra[2]+(ra[3]+ra[4]/60)/60)/24;
  if b_cycle=1 then write(days[b_cycle]:8:5)
  else writeln(' d (start)',cl,days[2]:8:5,' d (end)');
 end;
if paramcount>1 then writeln(days[2]-days[1]:8:5,' d (time)');
if paramcount>2 then
 begin
  val(paramstr(3),w_days,i);
  if paramcount>3 then 
   begin
    c:=paramstr(4);
    if UpCase(c[1])='H' then W_days:=W_days/24;
   end;  
  if w_days<>0 then
   writeln((days[2]-days[1])/w_days:8:5,' ',c,' (ratio)')
 end
end.

