 {~ Redirects <Ctrl><PrtScr> (copy of a text screen) to a file instead of prn~}

program slohni; {in Slovak, obtained from some BBS,
                probably by "HAM Software"
                makes a copy of a screen to a file instead of prn
                on <PrtScr>
                English output by Jenik Hollan}
{$M 8192,0,0}
{$V-,D-,I-,R-,S-}

uses Crt,Dos;

type Byty=record
     z,poz:char;
     end;
type Pole=array [1..4000] of Byty;

var tt:file;
    ScreenAdr:word;
    Dir      :string[80];
    BackSlash:string[1];
    Command  :string[127];
    p        :pointer;
    Pol      :pole;
    i,j,k    :byte;
    Buf      :array[1..4190] of char;
    bj,result:word;
    Row      :byte absolute $40:$84;
    Col      :word absolute 0:$044a;

function Ex(s:string):boolean;
begin
     for i:=1 to 4 do s[i]:=UpCase(s[i]);
     s[0]:=#4;
     if s='EXIT' then Ex:=true else Ex:=false;
end;

procedure PrtScr; interrupt;
begin
     if not DirectVideo then
     begin
       writeln('DirectVideo=false');
       DirectVideo:=true;
     end;
     move (Mem[ScreenAdr:0],Pol[1],8000);
 FileMode:=2; {will open the files by reset as Read Only}
     reset (tt,1);
     seek (tt,FileSize(tt));
     bj:=0;
     for i:=0 to Row do begin
       k:=Succ(Col);
       repeat Dec(k) until (Pol[i*Col+k].z>#32)
                     or (k=0) or ((i*Col+k)=1);
       if k>0 then for j:=1 to k do begin
          inc(bj);
          if Pol[i*Col+j].z in [#32..#254]
          then Buf[bj]:=Pol[i*Col+j].z
          else Buf[bj]:=#32;
       end;
       inc(bj);
       Buf[bj]:=#13;
       inc(bj);
       Buf[bj]:=#10;
       end;
       for k:=1 to 80 do
       begin
           inc(bj); Buf[bj]:='-';

       end;
       inc(bj); Buf[bj]:=#13;
       inc(bj); Buf[bj]:=#10;
       BlockWrite(tt,Buf,bj,result);

       delay(1);
       sound(200);
       delay (100);
       nosound;
       close(tt);
 FileMode:=0; {will open the files by reset as Read Only}
end;



begin
     if ParamCount<>1 then begin
        {writeln ('Musi byt uvedene meno suboru');}
      writeln ('I need a name of file, where the text screen will be stored.');
        halt(0);
     end;
     if LastMode=7 then ScreenAdr:=$b000
        else ScreenAdr:=$b800;
        GetDir(0,Dir);
        if Dir[ord(Dir[0])]='\'
          then BackSlash:=''
          else BackSlash:='\';
       assign(tt,Dir+BackSlash+ParamStr(1));
       rewrite(tt,1);
       close (tt);
       GetIntVec($05,p);
       SetIntVec($05,@PrtScr);
       {writeln ('"Slohni" je nainstalovany !!!');}
       writeln (
'"Slohni" is installed. <PrintScreen> prints to ',ParamStr(1),' now.',
  #13#10#10,
 'Uninstall by command: exit');
       repeat
             GetDir(0,Dir);
             write ('<PS> ',Dir,'>');
             readln(Command);
             if not Ex(Command) then begin
                SwapVectors;
                Exec(GetEnv('COMSPEC'), '/C ' + Command);
                SwapVectors;
                if DosError <>0
                   then {writeln('COMMAND.COM sa neda spustit');}
                        writeln ('COMMAND.COM not found.');
                   writeln;
                end;
                until Ex(Command);
                SetIntVec($05,p);
end.
