 {~ Number of different operations per 0.01 s ~} 

{Jan Hollan wrote this to see, which operations are to be avoided 
 if large data are processed}

program testspee;
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses dos;
const cl=#13#10;
var w,ws,hh,mm,ss,sso,hs,hso,tn,told,k,NOB:word; rw,rk,rws:real; j,NoOp:longint;

procedure wr(s:string);
begin
getTime(hh,mm,ss,hs);
tn:=hs+100*ss;
told:=hso+100*sso;
writeln(j div (tn-told) :5,'  ',s);
end;

function en:boolean;
begin
getTime(hh,mm,ss,hs);
tn:=hs+100*ss;
told:=hso+100*sso;
if told>tn then inc(tn,6000);
if tn>told+25 then en:=true
else
 begin
  en:=false;
  NoOp:=NoOp shl 1;
  NOB:=NOB shl 1;
  GetTime(hh,mm,sso,hso);
 end;
end;

Procedure ini_N(base:longint);
begin
 if NOB<4 then NOB:=4;
 NoOp:=base*100*(NOB shr 2);
 NOB:=1;
 getTime(hh,mm,sso,hso);
end;

begin
w:=12345;
ws:=123;
rw:=123.45;
rws:=1.2345;
writeln(
'Test of speed of different operations:',cl,
'n/0.01s   operation');
getTime(hh,mm,sso,hso);
NOB:=4;
ini_N(1000); repeat for j:= 1 to NoOp do k:= w shr 1  until en; wr('shr 1');
ini_N(1000); repeat for j:= 1 to NoOp do k:= w div 8  until en; wr('div 8');
ini_N(1000); repeat for j:= 1 to NoOp do if ws=1234 then until en; wr('if word=word');
ini_N(1000); repeat for j:= 1 to NoOp do case ws of
                         123: ; 122: ; else ; end; until en; wr('case command');
ini_N(700); repeat for j:= 1 to NoOp do k:= w  *  3  until en; wr(' *  3');
ini_N(600); repeat for j:= 1 to NoOp do k:= ws * ws  until en; wr('word*word');
ini_N(500); repeat for j:= 1 to NoOp do k:=w div 5432 until en; wr('div 5432');
ini_N(200); repeat for j:= 1 to NoOp do if rw>rws then until en; wr('if real>real');
ini_N(100); repeat for j:= 1 to NoOp do k:= sqr(ws)  until en; wr('sqr(word)');
ini_N(100); repeat for j:= 1 to NoOp do k:=round(rw) until en; wr('round');
ini_N(100); repeat for j:= 1 to NoOp do rk:= rw * 2.0 until en; wr('real * 2.0');
ini_N(50); repeat for j:= 1 to NoOp do rk:= sqr(rw)  until en; wr('sqr(real)');
ini_N(50); repeat for j:= 1 to NoOp do rk:= rw * 987654.321 until en; wr('* 987654.321');
ini_N(20); repeat for j:= 1 to NoOp do rk:= rw/ 1.000 until en; wr('real / 1.000');
ini_N(20); repeat for j:= 1 to NoOp do rk:= rw/54.321 until en; wr('real /54.321');
ini_N( 5); repeat for j:= 1 to NoOp do rk:= sin(rws)  until en; wr('sin');
ini_N( 3); repeat for j:= 1 to NoOp do rk:= exp(rws)  until en; wr('exp');
ini_N( 3); repeat for j:= 1 to NoOp do rk:= ln(rw)  until en; wr('ln');
ini_N( 3); repeat for j:= 1 to NoOp do rk:= sqrt(rw)  until en; wr('sqrt');
writeln(
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
end.
