 {~ Subtracts dark frame from an image by ST4 CCD camera ~}

Program Subtract_dark_frame;

const cl=#13#10;
h1= cl+
'S4DF <ST4 - raw picture file name> <ST4 - dark frame file name> '+cl+cl+

' subtracts a dark frame from a picture; overflow is preserved.'+cl+
' A file with .s4s suffix is created.'+cl;

dfs1:string[15]=
'Dark frame from';
dfs2:string =
') subtracted';
{
 Picture taken 08/02/94 at 02:18:20}

var
  buf,buf1: array[1..166,1..192] of byte;
  m,k: byte;
  inp: file;
  aux_s:string;
  NumRead:word;
  aux_i:integer;

procedure help;
  begin
   write(h1); HALT
  end;


begin
 IF pARAMCOUNT<2 THEN HELP;
{$I-}
 assign(inp,paramstr(2));
 reset(inp,192);
 if IORESULT<>0 THEN 
  begin 
   aux_s:=ParamStr(2);
   if not ((aux_s[2]='/') or (aux_s[2]='?')) then
    writeln('There is no file >',ParamStr(2),'< in this directory!');
   help
  end;
 BlockRead(inp,buf,166,NumRead);
 close(inp);
 assign(inp,paramstr(1));
 reset(inp,192);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(1);
   if not ((aux_s[1]='/') or (aux_s[1]='?')) then
    writeln('There is no file >',ParamStr(1),'< in this directory!');
   help
  end;
{$I+}
 BlockRead(inp,buf1,166,NumRead);
 close(inp);
 for m:=1 to 165 do for k:=1 to 192 do
  begin
   aux_i:=4+buf1[m,k]-buf[m,k];
   if (aux_i>255) or (buf1[m,k]=255) then buf1[m,k]:=255
   else if aux_i<0 then buf1[m,k]:=0
        else buf1[m,k]:=aux_i
  end;
 m:=2;
 move(dfs1[1],buf1[166,121],15);
 move(buf[166,15],buf1[166,136],21);
 dfs2:=' ('+paramstr(2)+dfs2;
 move(dfs2[1],buf1[166,157],length(dfs2));
 if pos('.',paramstr(1))>0 then
  assign(inp,copy( paramstr(1),1,pos('.',paramstr(1)) )+'s4s')
 else
  assign(inp,paramstr(1)+'.s4s');
 rewrite(inp,192);
 BlockWrite(inp,buf1,166,NumRead);
 close(inp)
end.

