@echo off
echo  This batch file will plot a map from
echo  the MegaStar version of the Guide Star Catalog
echo                    centered on a planet
echo  whose number (0: Sun, 1: Mercury, ... 9: Pluto, 10:Moon)
echo            is given as a first parameter (used just for centering the map)

if "%1"==""  goto need
shift

@echo on
plan.exe c c%0 %1 %2 %3 %4 %5 %6 %7 %8 %9 > %temp%RADecl.tmp
if errorlevel==1 goto map
@echo off
echo                    -------------------
echo Sorry, the parameters supplied conflict with the Plan ephemeris programme.
goto end
:map

@echo off
echo   Some parameters of the mapping programme map_MGSC are predefined here:
echo                       Side (vertical) of the field as 6 degrees,
echo                          Faintness Limit 110 dmag
echo                                Faintness Base 30 dmag
echo                                     Faintness for Description under 60 dmag
@echo on
map_MGSC @%temp%RADecl.tmp s6 fl110 fb30 fd60 %1 %2 %3 %4 %5 %6 %7 %8 %9
@echo off
goto end

:need
echo                            ----------------
echo Once again: The first parameter should be number 0..2, 4..10

:end
