 {~ Faintness of a group of stars from faintnesses of its members ~}

Program Mul_Fai; {by Jan Hollan}
uses str_num;
var
 LnM,V:real;
 i:integer;
begin
LnM:=Ln(10)/2.5;
if paramcount<2 then
 begin
  writeln(
'Mul_Fai computes the faintness (Sterngroesse, in German) of a group of stars.',cl,
'    Faintnesses of its members (/ 1 magnitude) are to be given as parameters.',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)');
  halt;
 end;
V:=N_S(paramstr(1));
if paramcount > 1 then for i:=2 to paramcount do
  V:=V-(ln(1+exp((V-N_S(paramstr(i)))*LnM))/LnM);
writeln('The faintness of the group is ',V:6:3, 'mag')
end.
