 {~ Checking the file on being directly e-mailable ~}

 { Has to be converted to the appropriate code page, if the simple frame
   characters (see lines 81--83) are different in that page;
   the original code page is 'Kamenicky'}



program In32_127;

USES DOS;
var infile : file;
    outscope : text;
    chars : array[1..2048] of char;
   Bznak : array[1..2048] of byte absolute chars;
 jw,NoRead: word;
  DoWrite: boolean; par:string;
const
 out32_127 : word = 0;  repla:boolean = False; cl=#13#10;
 appendfile:boolean=false;  toscreen:boolean=false;
 firstover:boolean=true;
begin
if (paramcount<1) or ((paramcount>0) and (pos('?',paramstr(1))>0)) then
 begin
writeln(
'In32_127 <name of file> [r|a|s]',cl,cl,

'checks if the file contains just characters 32 to 127, CR and LF.',cl,
'r  demands replacing some charecters of frames by -,+,|',cl,
'a  appending to the Ou32_127.txt rather then rewriting it,',cl,
's  writes the out-of-scope characters to screen as well',cl,
' - these characters are always written into Ou32_127.TXT',cl,
' (created in the directory given by TEMP variable, if exists)',cl,cl,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
  exit
 end;
assign (infile,ParamStr(1));
reset (infile,1);
if paramcount>1 then
 begin
  par:=paramstr(2);
  case UpCase(par[1]) of
   'R': repla:=True;
   'A': appendfile:=true;
   'S': toscreen:=true;
  end;
 end;

assign(outscope,getenv('TEMP')+'Ou32_127.TXT');
if appendfile then
 begin
  if FSearch(getenv('TEMP')+'Ou32_127.TXT','')<>'' then
   append(outscope)
  else
   REWRITE(outscope);
 end
else
 REWRITE(outscope);
NoRead:=2048;
While NoRead=2048 do
 begin
  blockread (infile,chars,2048,NoRead);
  DoWrite:=false;
  for jw:=1 to NoRead do
        if (Bznak[jw]>127) or (Bznak[jw] in [0..9,11..12,14..31]) then
           begin
             inc(out32_127);
             if firstover then
              begin
               firstover:=false;
               if appendfile then writeln(outscope,cl,paramstr(1),': ');
              end;
             if repla then
              begin
               DoWrite:=true;
               case chars[jw] of
                 '' : chars[jw]:= '-';
                 '' : chars[jw]:= '|';
                 '' : chars[jw]:= '+';
                ELSE  begin write(outscope,chars[jw]); chars[jw]:= ' 'end;
                end;
              end
             else
              write(outscope,chars[jw]);
           end;
  if DoWrite then
   begin
    seek(infile,FilePos(infile)-NoRead);
    blockwrite(infile,chars,NoRead)
   end;
 end;
if out32_127>0 then
 begin
  writeln(
'Over 127 and under 32 (without CR LF) are ',out32_127,
            ' characters (see Ou32_127.txt in TEMP)');
  if toscreen then
   begin
    close(outscope); reset(outscope); readln(outscope,par);
    writeln(par);
   end;
 end
else
 writeln('The file is a pure text one.');
CLOSE(outscope);
close(infile);
end.
