Program offansi;

const cl=#13#10;
h1= cl+
'OffANSI <input file with ANSI escape sequences (log of a terminal session)>'+cl+
'        <ouptut file without those sequences>'+cl
                                                     +cl+
' filters out "ANSI escape sequences" controlling the screen outlook'+cl;
h2=
' to make the output a plain text file'+cl+
' (sequences ending at K,J,m,D are simply ignored,'+cl+
'  those ending with H,C are replaced by a space,'+cl+
'                    B                by a new line'+cl+
'  other final characters are currently NOT RECOGNIZED).'+cl;
h3= cl+
'Jan Hollan, N. Copernicus Obs. and Planet. made for his needs in March, 1995'+cl+
'(source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
+cl;


const
 Size_of_Buf=30000;
 NoEsc:boolean=true;
var
  bi,bo: array[1..Size_of_Buf] of byte;
  ci: array [1..Size_of_Buf] of char absolute bi;
  co: array [1..Size_of_Buf] of char absolute bo;
  w,x,NumRead,NumWritten: word;
  inp,out: file;
  aux_s:string;

procedure help(message:string);
  begin
   writeln(message);
   write(h1); write(h2); write(h3); HALT
  end;


begin
 IF pARAMCOUNT<2 THEN HELP('');
{$I-}
 assign(inp,paramstr(1));
 reset(inp,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(1);
   if not ((aux_s[2]='/') or (aux_s[2]='?')) then
    help('There is no file >'+ParamStr(1)+'< in this directory!')
   else help('')
  end;
 assign(out,paramstr(2));
 rewrite(out,1);
 if IORESULT<>0 THEN
  begin
   aux_s:=ParamStr(2);
   if not ((aux_s[1]='/') or (aux_s[1]='?')) then
    help('Cannot open an output file >'+ParamStr(2)+'< !')
   else help('')
  end;
{$I+}
 BlockRead(inp,bi,Size_of_Buf,NumRead);
 x:=1;
 while NumRead>0 do
  begin
   for w:=1 to NumRead do
    if NoEsc then
     if bi[w]<>27 then
      begin
       bo[x]:=bi[w];
       inc(x);
      end
     else
       NoEsc:=false
    else
      case ci[w] of
       'K','J','m','D': NoEsc:=true;
       'B': begin NoEsc:=true; bo[x]:=10; inc(x) end;
       'H','C': begin NoEsc:=true; bo[x]:=32; inc(x) end;
      end;
   BlockWrite(out,bo,x,NumWritten);
   if NumWritten<x then help('Disk full, cannot write the ouptut file!');
   BlockRead(inp,bi,Size_of_Buf,NumRead);
   x:=1;
  end;

 close(inp);
 close(out)
end.

