 {~ An overview of numbered Borland Turbo Pascal fonts ~}

program numfont; {shows the actual numbered Borland Turbo Pascal fonts}
      {by Jan Hollan, when learning using fonts; 
       edited from a Czech source code by Ondrej Cada
       that came to me in a package containing *.chr
       with accented Czech letters in Kamenicky's code table}

uses crt, graph, dos,
     G_scree; {J.H's unit, for hardcopies}

procedure testgrapherror;
var  i : integer;
begin
  i:=graphresult;
  if i<>grOk then begin
    closegraph;
    writeln('Graphic driver error No.: ',grapherrormsg(i));
    halt(0);
  end
end;

{ main program }

var
  pathtodriver,cf,th,si : string;
  fname: array [1 .. 20] of string;
  gd,gm,font,Y,size : integer;
  j,h:byte;
  c:char;


begin
  pathtodriver:=getenv('BGI');
  Y:=0;
    detectgraph(gd,gm);
    initgraph(gd,gm,pathtodriver);
    testgrapherror;
  for j:= 1 to 9 do
 begin
    settextstyle(j,0,10);
    str(j:2,cf);
    H:=textheight('font No.'+cf);
    size:= 13000 div h;
    setusercharsize(size,100,size,100);
    H:=textheight('font No.'+cf);
    testgrapherror;
    str(size:4,si);
    inc(Y,round(H*1.2));
    MoveTo(20,Y);
    str(H:2,th);
    outtext('font No.'+cf+' size'+si+'/100, '+th+' high');
 end;
 repeat until keypressed;
 c:=readkey;
 if c=#0 then
  begin
   c:=readkey;
   if c=#114 then PriGScrC
  end;
 closegraph
end.

